use Gtk2;
use Glib;
init Gtk2;
use File::Basename;

sub get_widget_name ($) {
	my $widgets = shift;
	my $this_widget = shift;
	foreach (keys %{$widgets}) {
		return $_ if $widgets->{$_} == $this_widget;
	}
	return undef;
}

sub connect_signals ($$@) {
	my ($widgets, $signal, $function, @data) = @_;
	foreach (@data) {
		$widgets->{$_}->signal_connect($signal, $function);
	}
}

sub create_stock_buttons
{	
	my $factory = Gtk2::IconFactory->new;
	$factory->add_default;	
 	my $style = new Gtk2::Style;
	my @items = (
  	{	stock_id => "ar_quit",			label => "Quit",		icon => 'gtk-quit' },
		{	stock_id => "ar_start",			label => "_Start",	icon => 'gtk-convert' },
		{	stock_id => "ar_load",			label => "Reload",	icon => 'gtk-cdrom' },
		{	stock_id => "ar_compact",		label => "Compact",	icon => 'gtk-cdrom' },
		{	stock_id => "ar_view",			label => "View",		icon => 'gtk-yes' },
		{	stock_id => "ar_queue",			label => "_Queue",	icon => 'gtk-add' },
		{	stock_id => "ar_preview",		label => "Preview",	icon => 'gtk-zoom-in' },
		{	stock_id => "ar_debug",			label => "Debug",		icon => 'gtk-go-down' },		
		{	stock_id => "ar_clear",	    label => "Clear",		icon => 'gtk-clear' },
		{	stock_id => "ar_log_save",	label => "Save",		icon => 'gtk-save' },
		{	stock_id => "ar_export",  	label => "Export",  icon => 'gtk-save' },
		{	stock_id => "ar_log_hide",	label => "Hide",		icon => 'gtk-go-up' },
		{	stock_id => "ar_stop",			label => "Stop",		icon => 'gtk-stop' }
	);
  Gtk2::Stock->add(@items);
	foreach (@items) {
		$factory->add($_->{'stock_id'}, $style->lookup_icon_set($_->{'icon'}));
	}
}

sub new {
    my $class = shift;

    my $widgets;
		my $row_height = 4;
	
		create_stock_buttons();
    #
    # Construct a GtkWindow 'acidrip'
    $widgets->{'acidrip'} = new Gtk2::Window;
    $widgets->{'acidrip'}->set_title('acidrip');
    $widgets->{'acidrip'}->set_resizable(0);
    $widgets->{'acidrip'}->realize;
		#
		# Construct a GtkVBox 'status_vbox'
		$widgets->{'status_vbox'} = new Gtk2::VBox(0, 0); 
		$widgets->{'acidrip'}->add($widgets->{'status_vbox'});
		$widgets->{'status_vbox'}->show;

		$widgets->{'main_table'} = new Gtk2::Table(10, 2, 0);
		$widgets->{'main_table'}->show;

		# Construct a GtkHBox 'main_hbox'
		$widgets->{'main_hbox'} = new Gtk2::HBox(0, 0);
		$widgets->{'status_vbox'}->add($widgets->{'main_hbox'});
		$widgets->{'main_hbox'}->show;
		#
	  # Construct a GtkVBox 'left_vbox'
	  $widgets->{'left_vbox'} = new Gtk2::VBox(0, 0);
	  $widgets->{'main_hbox'}->add($widgets->{'left_vbox'});
	  $widgets->{'left_vbox'}->show;
		#
	  # Construct a GtkVBox 'notebook_vbox'
	  $widgets->{'notebook_vbox'} = new Gtk2::VBox(0, 0);
	  $widgets->{'notebook_vbox'}->show;
		#
		# notebook
		$widgets->{'notebook'} = new Gtk2::Notebook();
		$widgets->{'notebook'}->show;
		$widgets->{'notebook'}->set_border_width(2);
		$widgets->{'left_vbox'}->add($widgets->{'notebook'});
		$widgets->{'notebook'}->append_page($widgets->{'notebook_vbox'}, new Gtk2::Label("General"));

### GENERAL FRAME

		# Construct a GtkFrame 'general_frame'
		$widgets->{'general_frame'} = new Gtk2::Frame('General');
		$widgets->{'general_frame'}->set_shadow_type('etched_in');
		$widgets->{'notebook_vbox'}->add($widgets->{'general_frame'});
		$widgets->{'general_frame'}->show;
		$widgets->{'general_frame'}->set_border_width(2);
		#
		# Construct a GtkTable 'general_table'
		$widgets->{'general_table'} = new Gtk2::Table(5, 4, 0);
		$widgets->{'general_frame'}->add($widgets->{'general_table'});
		$widgets->{'general_table'}->set_row_spacings($row_height);
		$widgets->{'general_table'}->show;
		#
		# Construct a GtkLabel 'filename_label'
		$widgets->{'title_label'} = new Gtk2::Label('Disc title');
		$widgets->{'general_table'}->attach($widgets->{'title_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		$widgets->{'title_label'}->show;
		$widgets->{'title_label'}->set_alignment(0,0);
		#
		# Construct a GtkEntry 'filename'
		$widgets->{'title_entry'} = new Gtk2::Entry;
		$widgets->{'title_entry'}->show;
		$widgets->{'title_entry'}->set_size_request(10, -1);
		$widgets->{'general_table'}->attach($widgets->{'title_entry'}, 1, 5, 0, 1, ['fill'], [], 2, 2);
		#
		# Construct a GtkLabel 'filename_label'
		$widgets->{'filename_label'} = new Gtk2::Label('File name');
		$widgets->{'general_table'}->attach($widgets->{'filename_label'}, 0, 1, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'filename_label'}->show;
		#
		# Construct a GtkEntry 'filename'
		$widgets->{'filename_entry'} = new Gtk2::Entry;
		$widgets->{'filename_entry'}->show;
		$widgets->{'filename_entry'}->set_size_request(10, -1);
		$widgets->{'general_table'}->attach($widgets->{'filename_entry'}, 1, 4, 1, 2, ['fill'], [], 2, 2);
		#
		#$widgets->{'directory_entry'} = new Gtk2::Entry;

		$widgets->{'mpegfile_option'} = new Gtk2::OptionMenu;
		$widgets->{'mpegfile_menu'} = new Gtk2::Menu;
		$widgets->{'mpegfile_option'}->set_menu($widgets->{'mpegfile_menu'});
		$widgets->{'mpegfile_menu'}->append(new Gtk2::MenuItem(".avi"));
		$widgets->{'mpegfile_menu'}->append(new Gtk2::MenuItem(".mpg"));
		$widgets->{'mpegfile_option'}->set_history($::settings->{'mpegfile'});
		$widgets->{'mpegfile_option'}->show_all;

    $widgets->{'general_table'}->attach($widgets->{'mpegfile_option'}, 4, 5, 1, 2, ['fill'], [], 2, 2);			
		
		# Construct a GtkLabel 'filesize_label'
		$widgets->{'filesize_label'} = new Gtk2::Label('File size');
		$widgets->{'general_table'}->attach($widgets->{'filesize_label'}, 0, 1, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'filesize_label'}->show;
		$widgets->{'filesize_label'}->set_alignment(0, 0);

		# Construct a GtkCombo 'filesize_spin'			
		$widgets->{'filesize_adjust'} = new Gtk2::Adjustment(700, 1, 9999, 1, 50, 1);
		$widgets->{'filesize_spin'} = new Gtk2::SpinButton($widgets->{'filesize_adjust'}, 1, 0);
		$widgets->{'filesize_spin'}->set_size_request(50, -1);
		$widgets->{'general_table'}->attach($widgets->{'filesize_spin'}, 1, 2, 2, 3, ['expand', 'fill'], [], 2, 2);
		$widgets->{'filesize_spin'}->show;
		
		$widgets->{'filesize_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'filesize_entry'}, 1, 2, 2, 3, ['expand', 'fill'], [], 2, 2);		
		$widgets->{'filesize_entry'}->set_size_request(50, -1);
		$widgets->{'filesize_entry'}->set_editable(0);
		
		$widgets->{'total_blocks_label'} = new Gtk2::Label("# Files");
		$widgets->{'general_table'}->attach($widgets->{'total_blocks_label'}, 2, 4, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'total_blocks_label'}->show;
			
		$widgets->{'total_blocks_adjust'} = new Gtk2::Adjustment(1, 1, 10, 1, 1, 1);
		$widgets->{'total_blocks_spin'} = new Gtk2::SpinButton($widgets->{'total_blocks_adjust'}, 1, 0);
		$widgets->{'general_table'}->attach($widgets->{'total_blocks_spin'}, 4, 5, 2, 3, [ 'fill'], [], 2, 2);			
		$widgets->{'total_blocks_spin'}->show;
		
		#$widgets->{'total_blocks_spin'}->set_size_request(40, -1);
		
		$widgets->{'info_label'} = new Gtk2::Label('Info');
		$widgets->{'general_table'}->attach($widgets->{'info_label'}, 0, 1, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_label'}->set_alignment(0,0);
		$widgets->{'info_label'}->show;

		$widgets->{'info_field_option'} = new Gtk2::OptionMenu;
		$widgets->{'info_field_menu'} = new Gtk2::Menu;
		$widgets->{'info_field_option'}->set_menu($widgets->{'info_field_menu'});
		$widgets->{'info_field_option'}->set_size_request(40, -1);
		$widgets->{'general_table'}->attach($widgets->{'info_field_option'}, 1, 2, 3, 4, [ 'fill'], [], 2, 2);
		
		foreach ( "name", "artist", "subject", "genre", "copyright" ) {
			my $item = new Gtk2::MenuItem($_);
			$item->signal_connect("activate", \&on_info_field_select, $_);
			$widgets->{'info_field_menu'}->append($item);			
		}
		$widgets->{'info_field_option'}->set_history(0);
		$widgets->{'info_field_option'}->show_all;
		
		$widgets->{'info_name_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_name_entry'}, 2, 5, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_name_entry'}->set_size_request(40, -1);
		$widgets->{'info_name_entry'}->show;
			
		$widgets->{'info_artist_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_artist_entry'}, 2, 5, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_artist_entry'}->set_size_request(40, -1);

		$widgets->{'info_subject_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_subject_entry'}, 2, 5, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_subject_entry'}->set_size_request(40, -1);

		$widgets->{'info_genre_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_genre_entry'}, 2, 5, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_genre_entry'}->set_size_request(40, -1);

		$widgets->{'info_copyright_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_copyright_entry'}, 2, 5, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_copyright_entry'}->set_size_request(40, -1);

		$widgets->{'info_comment_entry'} = new Gtk2::Entry;
		$widgets->{'general_table'}->attach($widgets->{'info_comment_entry'}, 2, 5, 3, 4, [ 'fill'], [], 2, 2);
		$widgets->{'info_comment_entry'}->set_size_request(40, -1);

		$widgets->{'notebook_vbox'}->set_child_packing($widgets->{'general_frame'}, 1, 1, 0, 'start');

### AUDIO FRAME
		
		# Construct a GtkFrame 'audio_frame'
		$widgets->{'audio_frame'} = new Gtk2::Frame('Audio');
		$widgets->{'audio_frame'}->set_shadow_type('etched_in');
		$widgets->{'notebook_vbox'}->add($widgets->{'audio_frame'});
		$widgets->{'audio_frame'}->show;
		$widgets->{'audio_frame'}->set_border_width(2);
		#
		# Construct a GtkTable 'audio_table'
		$widgets->{'audio_table'} = new Gtk2::Table(3, 5, 0);
		$widgets->{'audio_frame'}->add($widgets->{'audio_table'});
		$widgets->{'audio_table'}->set_row_spacings($row_height);
		$widgets->{'audio_table'}->show;
		#
		# Construct a GtkLabel 'language_label'
		$widgets->{'audio_track_label'} = new Gtk2::Label('Language');
		$widgets->{'audio_table'}->attach($widgets->{'audio_track_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		$widgets->{'audio_track_label'}->show;
		$widgets->{'audio_track_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkCombo 'language_combo'
		$widgets->{'audio_track_option'} = new Gtk2::OptionMenu;
		$widgets->{'audio_track_menu'} = new Gtk2::Menu;
		$widgets->{'audio_track_option'}->set_menu($widgets->{'audio_track_menu'});
		$widgets->{'audio_track_menu'}->append(Gtk2::MenuItem->new("<Default> $::settings->{'language'}"));
		$widgets->{'audio_table'}->attach($widgets->{'audio_track_option'}, 1, 5, 0, 1, ['expand', 'fill'], [], 2, 2);
		$widgets->{'audio_track_option'}->show_all;
		$widgets->{'audio_track_option'}->set_history(0);
		#
		# Construct a GtkLabel 'audio_options_label'
		$widgets->{'audio_options_label'} = new Gtk2::Label('Options');
		$widgets->{'audio_table'}->attach($widgets->{'audio_options_label'}, 0, 1, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'audio_options_label'}->show;
		$widgets->{'audio_options_label'}->set_alignment(0, 0.5);
			
		$widgets->{'audio_options_entry'} = new Gtk2::Entry;
		$widgets->{'audio_table'}->attach($widgets->{'audio_options_entry'}, 1, 5, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'audio_options_entry'}->show;
		$widgets->{'audio_options_entry'}->set_size_request(50, -1);

		# Construct a GtkLabel 'audio_codec_label'
		$widgets->{'audio_codec_label'} = new Gtk2::Label('Codec');
		$widgets->{'audio_table'}->attach($widgets->{'audio_codec_label'}, 0, 1, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'audio_codec_label'}->show;
		$widgets->{'audio_codec_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkCombo 'audio_codec_option'
		$widgets->{'audio_codec_option'} = new Gtk2::OptionMenu;
		$widgets->{'audio_codec_menu'} = new Gtk2::Menu;
		$widgets->{'audio_codec_option'}->set_menu($widgets->{'audio_codec_menu'});
		$widgets->{'audio_table'}->attach($widgets->{'audio_codec_option'}, 1, 3, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'audio_codec_option'}->show_all;		
		$widgets->{'left_vbox'}->set_child_packing($widgets->{'audio_frame'}, 1, 1, 0, 'start');
		
		# Construct a GtkCombo 'audio_codec_option'
		$widgets->{'audio_gain_label'} = new Gtk2::Label("Gain");
		$widgets->{'audio_table'}->attach($widgets->{'audio_gain_label'}, 3, 4, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'audio_gain_label'}->show;		
		
		$widgets->{'audio_gain_adjust'} = new Gtk2::Adjustment(0, -200, 40, 1, 5, 1);
		$widgets->{'audio_gain_spin'} = new Gtk2::SpinButton($widgets->{'audio_gain_adjust'}, 1, 0);
		#$widgets->{'audio_gain_spin'}->set_size_request(40, -1);
		$widgets->{'audio_table'}->attach($widgets->{'audio_gain_spin'}, 4, 5, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'audio_gain_spin'}->show;
		
		$widgets->{'mp3_type_label'} = new Gtk2::Label("Type");
		#$widgets->{'mp3_type_label'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_type_label'}, 3, 4, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'mp3_type_label'}->set_alignment(0, 0.5);

		$widgets->{'mp3_type_combo'} = new Gtk2::Combo;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_type_combo'}, 4, 5, 1, 2, ['fill'], [], 2, 2);
		$widgets->{'mp3_type_combo'}->set_popdown_strings('abr', 'cbr', 'vbr');
		#$widgets->{'mp3_type_combo'}->show;
		$widgets->{'mp3_type_combo'}->set_size_request(50, -1);

		$widgets->{'mp3_bitrate_label'} = new Gtk2::Label("Bitrate");
		#$widgets->{'mp3_bitrate_label'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_bitrate_label'}, 3, 4, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_bitrate_label'}->set_alignment(0, 0.5);

		$widgets->{'mp3_bitrate_entry'} = new Gtk2::Entry;
		#$widgets->{'mp3_bitrate_entry'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_bitrate_entry'}, 4, 5, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_bitrate_entry'}->set_size_request(50, -1);

		$widgets->{'mp3_quality_label'} = new Gtk2::Label("Quality");
		#$widgets->{'mp3_quality_label'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_quality_label'}, 3, 4, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_quality_label'}->set_alignment(0, 0.5);

		$widgets->{'mp3_quality_entry'} = new Gtk2::Entry;
		#$widgets->{'mp3_quality_entry'}->show;
		$widgets->{'audio_table'}->attach($widgets->{'mp3_quality_entry'}, 4, 5, 2, 3, ['fill'], [], 2, 2);
		$widgets->{'mp3_quality_entry'}->set_size_request(50, -1);

### SUBTITLES

		$widgets->{'misc_table'} = new Gtk2::Table(4,2,0);
		$widgets->{'misc_table'}->show;
		$widgets->{'misc_table'}->set_row_spacings($row_height);

		$widgets->{'misc_frame'} = new Gtk2::Frame("Other stuff");
		$widgets->{'misc_frame'}->add($widgets->{'misc_table'});
		$widgets->{'notebook_vbox'}->add($widgets->{'misc_frame'});
		$widgets->{'misc_frame'}->show;
		$widgets->{'misc_frame'}->set_border_width(2);

		$widgets->{'subp_label'} = new Gtk2::Label('Subtitle ');
		$widgets->{'subp_label'}->show;
		$widgets->{'misc_table'}->attach($widgets->{'subp_label'}, 0, 1, 0, 1, ['fill'], [], 4, 2);
			
		$widgets->{'subp_option'} = new Gtk2::OptionMenu;
		$widgets->{'subp_menu'} = new Gtk2::Menu;
		$widgets->{'subp_option'}->set_menu($widgets->{'subp_menu'});
		$widgets->{'subp_menu'}->append(Gtk2::MenuItem->new("<None>"));
		$widgets->{'subp_option'}->show;
		$widgets->{'subp_option'}->set_history(0);
		$widgets->{'misc_table'}->attach($widgets->{'subp_option'}, 1, 2, 0, 1, ['fill', 'expand'], [], 2, 2);
		
		$widgets->{'vobsubout_check'} = new Gtk2::CheckButton('Sub File');
		$widgets->{'vobsubout_check'}->show;
		$widgets->{'misc_table'}->attach($widgets->{'vobsubout_check'}, 2, 3, 0, 1, ['fill'], [], 2, 2);
		
		$widgets->{'more_options_entry'} = new Gtk2::Entry;
		$widgets->{'more_options_entry'}->show;
		$widgets->{'more_options_label'} = new Gtk2::Label("Misc.");
		$widgets->{'more_options_label'}->set_alignment(0, 0.5);
		$widgets->{'more_options_label'}->show;

		$widgets->{'misc_table'}->attach($widgets->{'more_options_label'}, 0, 1, 1, 2, ['fill'], [], 4, 2);
		$widgets->{'misc_table'}->attach($widgets->{'more_options_entry'}, 1, 4, 1, 2, ['fill', 'expand'], [], 2, 2);

### VIDEO 

		# Construct a GtkFrame 'video_frame'
		$widgets->{'video_frame'} = new Gtk2::Frame('Video');
		$widgets->{'notebook'}->append_page($widgets->{'video_frame'}, new Gtk2::Label("Video"));
		$widgets->{'video_frame'}->show;
		$widgets->{'video_frame'}->set_border_width(2);

		# Construct a GtkTable 'video_table'
		$widgets->{'video_table'} = new Gtk2::Table(10, 5, 0);
		$widgets->{'video_table'}->set_row_spacings($row_height);
		$widgets->{'video_frame'}->add($widgets->{'video_table'});
		$widgets->{'video_table'}->show;

		$widgets->{'video_crop_seperator'} = new Gtk2::HSeparator;
		$widgets->{'video_crop_seperator'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_crop_seperator'}, 0, 5, 3, 4, ['fill'], ['expand'], 2, 2);

		# Construct a GtkCheckButton 'crop_enable_check'
		$widgets->{'crop_enable_check'} = new Gtk2::CheckButton("Crop");
		$widgets->{'video_table'}->attach($widgets->{'crop_enable_check'}, 0, 1, 4, 5, ['fill'], ['expand'], 2, 2);
		$widgets->{'crop_enable_check'}->set_active(1);
		$widgets->{'crop_enable_check'}->show;

		# Construct a GtkEntry 'crop_vertical_entry'
		$widgets->{'crop_vertical_adjust'} = new Gtk2::Adjustment(0, 0, 720, 1, 50, 200);
		$widgets->{'crop_vertical_spin'} = new Gtk2::SpinButton($widgets->{'crop_vertical_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_vertical_spin'}, 4, 5, 5, 6, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'crop_vertical_spin'}->show;
		$widgets->{'crop_vertical_spin'}->set_size_request(40, -1);

		# Construct a GtkEntry 'crop_horizontal_entry'
		$widgets->{'crop_horizontal_adjust'} = new Gtk2::Adjustment(0, 0, 576, 1, 50, 200 );
		$widgets->{'crop_horizontal_spin'} = new Gtk2::SpinButton($widgets->{'crop_horizontal_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_horizontal_spin'}, 4, 5, 4, 5, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'crop_horizontal_spin'}->show;
		$widgets->{'crop_horizontal_spin'}->set_size_request(40, -1);

		# Construct a GtkEntry 'crop_width_entry'
		$widgets->{'crop_width_adjust'} = new Gtk2::Adjustment(0, 0, 1000, 1, 50, 200 );
		$widgets->{'crop_width_spin'} = new Gtk2::SpinButton($widgets->{'crop_width_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_width_spin'}, 2, 3, 4, 5, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'crop_width_spin'}->show;
		$widgets->{'crop_width_spin'}->set_size_request(40, -1);

		# Construct a GtkEntry 'crop_height_entry'
		$widgets->{'crop_height_adjust'} = new Gtk2::Adjustment(0, 0, 1000, 1, 50, 200 );
		$widgets->{'crop_height_spin'} = new Gtk2::SpinButton($widgets->{'crop_height_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'crop_height_spin'}, 2, 3, 5, 6, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'crop_height_spin'}->show;
		$widgets->{'crop_height_spin'}->set_size_request(40, -1);

		# Construct a GtkLabel 'crop_vertical_label'
		$widgets->{'crop_vertical_label'} = new Gtk2::Label('Vert');
		$widgets->{'video_table'}->attach($widgets->{'crop_vertical_label'}, 3, 4, 5, 6, ['fill'], ['expand'], 2, 2);
		$widgets->{'crop_vertical_label'}->show;

		# Construct a GtkLabel 'crop_horizontal_label'
		$widgets->{'crop_horizontal_label'} = new Gtk2::Label('Horiz');
		$widgets->{'video_table'}->attach($widgets->{'crop_horizontal_label'}, 3, 4, 4, 5, ['fill'], ['expand'], 2, 2);
		$widgets->{'crop_horizontal_label'}->show;

		# Construct a GtkLabel 'crop_width_label'
		$widgets->{'crop_width_label'} = new Gtk2::Label('Width');
		$widgets->{'video_table'}->attach($widgets->{'crop_width_label'}, 1, 2, 4, 5, ['fill'], ['expand'], 2, 2);
		$widgets->{'crop_width_label'}->show;

		# Construct a GtkLabel 'crop_height_label'
		$widgets->{'crop_height_label'} = new Gtk2::Label('Height');
		$widgets->{'video_table'}->attach($widgets->{'crop_height_label'}, 1, 2, 5, 6, ['fill'], ['expand'], 2, 2);
		$widgets->{'crop_height_label'}->show;

		# Construct a GtkButton 'crop_detect_button'
		$widgets->{'crop_detect_button'} = new Gtk2::Button('Detect');
		$widgets->{'video_table'}->attach($widgets->{'crop_detect_button'}, 0, 1, 5, 6, ['fill'], ['expand'], 2, 2);
		$widgets->{'crop_detect_button'}->show;

		$widgets->{'video_scale_seperator'} = new Gtk2::HSeparator;
		$widgets->{'video_scale_seperator'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_scale_seperator'}, 0, 5, 6, 7, ['fill'], ['expand'], 2, 2);

		# Construct a GtkCheckButton 'scale_enable_check'
		$widgets->{'scale_enable_check'} = new Gtk2::CheckButton('Scale');
		$widgets->{'video_table'}->attach($widgets->{'scale_enable_check'}, 0, 1, 7, 8, ['fill'], ['expand'], 2, 2);
		$widgets->{'scale_enable_check'}->set_active(1);
		$widgets->{'scale_enable_check'}->show;

		# Construct a GtkLabel 'scale_width_label'
		$widgets->{'scale_width_label'} = new Gtk2::Label('Width');
		$widgets->{'video_table'}->attach($widgets->{'scale_width_label'}, 1, 2, 7, 8, ['fill'], ['expand'], 2, 2);
		$widgets->{'scale_width_label'}->show;
		#
		# Construct a GtkLabel 'scale_height_label'
		$widgets->{'scale_lock_check'} = new Gtk2::CheckButton('Lock aspect');
		$widgets->{'video_table'}->attach($widgets->{'scale_lock_check'}, 3, 5, 7, 8, ['fill'], ['expand'], 2, 2);
		$widgets->{'scale_lock_check'}->set_relief('none');
		$widgets->{'scale_lock_check'}->show;
		$widgets->{'scale_lock_check'}->set_active(1);
			    
		$widgets->{'scale_height_label'} = new Gtk2::Label('Height');
		$widgets->{'video_table'}->attach($widgets->{'scale_height_label'}, 1, 2, 8, 9, ['fill'], ['expand'], 2, 2);
		$widgets->{'scale_height_label'}->show;
		#
		# Construct a GtkEntry 'scale_width_entry'
		$widgets->{'scale_width_adjust'} = new Gtk2::Adjustment(1, -2, 1000, 1, 50, 200 );
		$widgets->{'scale_width_spin'} = new Gtk2::SpinButton($widgets->{'scale_width_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'scale_width_spin'}, 2, 3, 7, 8, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'scale_width_spin'}->show;
		$widgets->{'scale_width_spin'}->set_size_request(50, -1);
		#
		# Construct a GtkEntry 'scale_height_entry'
		$widgets->{'scale_height_adjust'} = new Gtk2::Adjustment(123, -2, 1000, 1, 50, 200 );
		$widgets->{'scale_height_spin'} = new Gtk2::SpinButton($widgets->{'scale_height_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'scale_height_spin'}, 2, 3, 8, 9, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'scale_height_spin'}->hide;
		$widgets->{'scale_height_spin'}->set_size_request(50, -1);
					
		$widgets->{'scale_height_estimate_entry'} = new Gtk2::Entry;
		$widgets->{'scale_height_estimate_entry'}->set_text("0");
		$widgets->{'video_table'}->attach($widgets->{'scale_height_estimate_entry'}, 2, 3, 8, 9, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'scale_height_estimate_entry'}->set_editable(0);
		$widgets->{'scale_height_estimate_entry'}->show;
		$widgets->{'scale_height_estimate_entry'}->set_size_request(50, -1);

		$widgets->{'video_filters_seperator'} = new Gtk2::HSeparator;
		$widgets->{'video_filters_seperator'}->show;
		$widgets->{'video_table'}->attach($widgets->{'video_filters_seperator'}, 0, 5, 9, 10, ['fill'], ['expand'], 2, 2);
		
		$widgets->{'vf_pre_enable_check'} = new Gtk2::CheckButton("Pre filters");
		$widgets->{'video_table'}->attach($widgets->{'vf_pre_enable_check'}, 0, 2, 10, 11, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'vf_pre_enable_check'}->set_active(1);
		$widgets->{'vf_pre_enable_check'}->show;

		$widgets->{'vf_pre_entry'} = new Gtk2::Entry;
		$widgets->{'vf_pre_entry'}->set_size_request(40, -1);
		$widgets->{'video_table'}->attach($widgets->{'vf_pre_entry'}, 2, 5, 10, 11, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'vf_pre_entry'}->show;

		$widgets->{'vf_post_enable_check'} = new Gtk2::CheckButton("Post filters");
		$widgets->{'video_table'}->attach($widgets->{'vf_post_enable_check'}, 0, 2, 11, 12, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'vf_post_enable_check'}->set_active(1);
		$widgets->{'vf_post_enable_check'}->show;
		
		$widgets->{'vf_post_entry'} = new Gtk2::Entry;
		$widgets->{'video_table'}->attach($widgets->{'vf_post_entry'}, 2, 5, 11, 12, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'vf_post_entry'}->show;
		$widgets->{'vf_post_entry'}->set_size_request(40, -1);

		# Construct a GtkLabel 'codec_label'
		$widgets->{'codec_label'} = new Gtk2::Label('Codec');
		$widgets->{'video_table'}->attach($widgets->{'codec_label'}, 0, 1, 0, 1, ['fill'], ['expand'], 2, 2);
		$widgets->{'codec_label'}->show;
		$widgets->{'codec_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkCombo 'codec_combo'
		$widgets->{'video_codec_option'} = new Gtk2::OptionMenu;
		$widgets->{'video_codec_menu'} = new Gtk2::Menu;
		$widgets->{'video_codec_option'}->set_menu($widgets->{'video_codec_menu'});
		$widgets->{'video_table'}->attach($widgets->{'video_codec_option'}, 1, 3, 0, 1, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'video_codec_option'}->show;
		$widgets->{'video_codec_option'}->set_size_request(40, -1);
	  #
		# Construct a GtkLabel 'lavc_label'
		$widgets->{'video_options_label'} = new Gtk2::Label('Options');
		$widgets->{'video_table'}->attach($widgets->{'video_options_label'}, 0, 1, 1, 2, ['fill'], ['expand'], 2, 2);
		$widgets->{'video_options_label'}->show;
		$widgets->{'video_options_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkEntry 'codec_options_entry'
		$widgets->{'video_options_entry'} = new Gtk2::Entry;
		$widgets->{'video_table'}->attach($widgets->{'video_options_entry'}, 1, 5, 1, 2, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'video_options_entry'}->show;
		
	  $widgets->{'video_bitrate_label'} = new Gtk2::Label('Bitrate');
	  $widgets->{'video_bitrate_label'}->show;
		$widgets->{'video_bitrate_label'}->set_alignment(0, 0.5);
		$widgets->{'video_table'}->attach($widgets->{'video_bitrate_label'}, 0, 1, 2, 3, ['fill'], ['expand'], 2, 2);

    $widgets->{'video_bitrate_entry'} = new Gtk2::Entry;
	  $widgets->{'video_bitrate_entry'}->set_editable(0);
		$widgets->{'video_bitrate_entry'}->set_size_request(50, -1);
		$widgets->{'video_table'}->attach($widgets->{'video_bitrate_entry'}, 1, 2, 2, 3, ['fill'], ['expand'], 2, 2);
    $widgets->{'video_bitrate_entry'}->show;

		$widgets->{'video_bitrate_adjust'} = new Gtk2::Adjustment(1, 1, 5000, 1, 50, 1);
		$widgets->{'video_bitrate_spin'} = new Gtk2::SpinButton($widgets->{'video_bitrate_adjust'}, 1, 0);
		$widgets->{'video_table'}->attach($widgets->{'video_bitrate_spin'}, 1, 2, 2, 3, ['fill'], ['expand'], 2, 2);
		#$widgets->{'video_bitrate_spin'}->show;
		$widgets->{'video_bitrate_spin'}->set_size_request(50, -1);
		
	  $widgets->{'video_bitrate_lock_check'} = new Gtk2::CheckButton('Lock');
	  $widgets->{'video_bitrate_lock_check'}->show;
	  $widgets->{'video_table'}->attach($widgets->{'video_bitrate_lock_check'}, 2, 3, 2, 3, ['fill'], ['expand'], 2, 2);
		
		$widgets->{'video_passes_adjust'} = new Gtk2::Adjustment(1, 1, 3, 1, 1, 1);
		$widgets->{'video_passes_spin'} = new Gtk2::SpinButton($widgets->{'video_passes_adjust'}, 1, 0);
		$widgets->{'video_passes_spin'}->show;
		$widgets->{'video_passes_label'} = new Gtk2::Label("Passes");
		$widgets->{'video_passes_label'}->show;	
		$widgets->{'video_table'}->attach($widgets->{'video_passes_label'}, 3, 4, 0, 1, ['fill'], ['expand'], 2, 2);
		$widgets->{'video_table'}->attach($widgets->{'video_passes_spin'}, 4, 5, 0, 1, ['fill'], ['expand'], 2, 2);
			
		$widgets->{'video_bpp_label'} = new Gtk2::Label("Bits/Pixel");
		$widgets->{'video_bpp_label'}->show;
		$widgets->{'video_bpp_entry'} = new Gtk2::Entry;
		$widgets->{'video_bpp_entry'}->show;
		$widgets->{'video_bpp_entry'}->set_editable(0);
		$widgets->{'video_bpp_entry'}->set_size_request(40, -1);
		$widgets->{'video_table'}->attach($widgets->{'video_bpp_label'}, 3, 4, 2, 3, ['fill'], ['expand'], 2, 2);
		$widgets->{'video_table'}->attach($widgets->{'video_bpp_entry'}, 4, 5, 2, 3, ['fill'], ['expand'], 2, 2);
		
		# Construct a GtkVBox 'right_vbox'
	  $widgets->{'right_vbox'} = new Gtk2::VBox(0, 0);
	  $widgets->{'main_hbox'}->add($widgets->{'right_vbox'});
	  $widgets->{'right_vbox'}->show;

		### DVD TREE
			
		# Construct a GtkFrame 'dvd_tree_frame'
		$widgets->{'dvd_tree_frame'} = new Gtk2::Frame('DVD contents');
		#$widgets->{'dvd_tree_frame'}->set_label_align(0, 0);
		$widgets->{'right_vbox'}->add($widgets->{'dvd_tree_frame'});
		$widgets->{'dvd_tree_frame'}->show;
		$widgets->{'dvd_tree_frame'}->set_border_width(2);
		#
		# Construct a GtkVBox 'dvd_tree_vbox'
		$widgets->{'dvd_tree_vbox'} = new Gtk2::VBox(0, 0);
		$widgets->{'dvd_tree_frame'}->add($widgets->{'dvd_tree_vbox'});
		$widgets->{'dvd_tree_vbox'}->show;
		#
		# Construct a GtkHBox 'dvd_device_hbox'
		$widgets->{'dvd_device_hbox'} = new Gtk2::HBox(0, 0);
		$widgets->{'dvd_tree_vbox'}->add($widgets->{'dvd_device_hbox'});
		$widgets->{'dvd_device_hbox'}->show;
		#
		# Construct a GtkLabel 'dvd_device'
		$widgets->{'dvd_device_label'} = new Gtk2::Label('Device');
		$widgets->{'dvd_device_hbox'}->add($widgets->{'dvd_device_label'});
		$widgets->{'dvd_device_label'}->show;
		$widgets->{'dvd_device_label'}->set_alignment(0.5, 0.5);
		$widgets->{'dvd_device_label'}->set_padding(2, 2);
		$widgets->{'dvd_device_hbox'}->set_child_packing($widgets->{'dvd_device_label'}, 0, 0, 0, 'start');
		#
		# Construct a GtkEntry 'dvd_device_entry'
		$widgets->{'dvd_device_entry'} = new Gtk2::Entry;
		$widgets->{'dvd_device_hbox'}->add($widgets->{'dvd_device_entry'});
		$widgets->{'dvd_device_entry'}->show;
		$widgets->{'dvd_device_entry'}->set_size_request(100, -1);
		$widgets->{'dvd_device_hbox'}->set_child_packing($widgets->{'dvd_device_entry'}, 0, 0, 0, 'start');
		#
		# Construct a GtkButton 'read_dvd_button'
		$widgets->{'read_dvd_button'} = Gtk2::Button->new_from_stock('ar_load');
		$widgets->{'dvd_device_hbox'}->add($widgets->{'read_dvd_button'});
		$widgets->{'read_dvd_button'}->show;
		$widgets->{'read_dvd_button'}->set_border_width(2);
		$widgets->{'dvd_device_hbox'}->set_child_packing($widgets->{'read_dvd_button'}, 1, 1, 0, 'start');
		$widgets->{'dvd_tree_vbox'}->set_child_packing($widgets->{'dvd_device_hbox'}, 0, 0, 0, 'start');
		#
		# Construct a GtkScrolledWindow 'tree_scroll_window'
		$widgets->{'tree_scroll_window'} = new Gtk2::ScrolledWindow( undef, undef);
		$widgets->{'tree_scroll_window'}->set_policy('never', 'always');
		$widgets->{'tree_scroll_window'}->set_border_width(2);
		$widgets->{'tree_scroll_window'}->set_shadow_type ('in');
		$widgets->{'dvd_tree_vbox'}->add($widgets->{'tree_scroll_window'});
		$widgets->{'tree_scroll_window'}->show;
		#
		# Construct a GtkTree 'dvd_tree'
		$widgets->{'dvd_tree'} = new Gtk2::TreeView;
		$widgets->{'dvd_tree'}->set_headers_visible(0);
		$widgets->{'tree_scroll_window'}->add($widgets->{'dvd_tree'});
		$widgets->{'dvd_tree'}->show;
		$widgets->{'dvd_tree'}->set_size_request(200, 0);
		$widgets->{'dvd_tree_vbox'}->set_child_packing($widgets->{'tree_scroll_window'}, 1, 1, 0, 'start');
		$widgets->{'right_vbox'}->set_child_packing($widgets->{'dvd_tree_frame'}, 1, 1, 0, 'start');
		
		$widgets->{'selected_track_label'} = new Gtk2::Label("No track selected");
		$widgets->{'dvd_tree_vbox'}->pack_end($widgets->{'selected_track_label'}, 0, 1, 2);
		$widgets->{'selected_track_label'}->show;
		$widgets->{'selected_track_label'}->set_alignment(0, 0);
		
		$widgets->{'cache_menc_vbox'} = new Gtk2::VBox();
		$widgets->{'right_vbox'}->pack_start($widgets->{'cache_menc_vbox'}, 0, 0, 0);
		$widgets->{'cache_menc_vbox'}->show;
		
### CACHE FRAME
		
		# Construct a GtkFrame 'cache_frame'
		$widgets->{'cache_frame'} = new Gtk2::Frame('Cache status');
		$widgets->{'cache_menc_vbox'}->pack_start($widgets->{'cache_frame'}, 0, 0, 2);
		$widgets->{'cache_frame'}->show;
		$widgets->{'cache_frame'}->set_border_width(2);
		#
		# Construct a GtkTable 'mencoder_table' 
		$widgets->{'cache_table'} = new Gtk2::Table(1, 4, 1);
		$widgets->{'cache_frame'}->add($widgets->{'cache_table'});
		$widgets->{'cache_table'}->show;
		
		$widgets->{'cache_chapter_label'} = new Gtk2::Label("Chapter:");
		$widgets->{'cache_chapter_label'}->show;
		$widgets->{'cache_chapter_label'}->set_alignment(0, 0.5);
		$widgets->{'cache_table'}->attach($widgets->{'cache_chapter_label'}, 0, 1, 0, 1, ['fill'], [], 2, 2);
		
		$widgets->{'cache_chapter'} = new Gtk2::Label("0 (0/0)");
		$widgets->{'cache_chapter'}->show;
		$widgets->{'cache_table'}->attach($widgets->{'cache_chapter'}, 1, 2, 0, 1, ['fill', 'expand'], [], 2, 2);
		
		$widgets->{'cache_size_label'} = new Gtk2::Label("Size:");
		$widgets->{'cache_size_label'}->show;		
		$widgets->{'cache_size_label'}->set_alignment(0, 0.5);
		$widgets->{'cache_table'}->attach($widgets->{'cache_size_label'}, 2, 3, 0, 1, ['fill', 'expand'], [], 2, 2);		

		$widgets->{'cache_size'} = new Gtk2::Label("0mb");
		$widgets->{'cache_size'}->show;
		$widgets->{'cache_table'}->attach($widgets->{'cache_size'}, 3, 4, 0, 1, ['fill', 'expand'], [], 2, 2);		

### MENCODER FRAME

		# Construct a GtkFrame 'menc_frame'
		$widgets->{'menc_frame'} = new Gtk2::Frame('Encoding status');
		$widgets->{'cache_menc_vbox'}->add($widgets->{'menc_frame'});
		#$widgets->{'main_table'}->attach($widgets->{'menc_frame'}, 1, 2, 4, 6, ['fill'], ['fill'], 2, 2);
		$widgets->{'menc_frame'}->show;
		$widgets->{'menc_frame'}->set_border_width(2);
		#
		# Construct a GtkTable 'mencoder_table'
		$widgets->{'mencoder_table'} = new Gtk2::Table(6, 2, 0);
		$widgets->{'menc_frame'}->add($widgets->{'mencoder_table'});
		$widgets->{'mencoder_table'}->show;
		#
		# Construct a GtkLabel 'menc_fps_label'
		$widgets->{'menc_fps_label'} = new Gtk2::Label('Encoding speed:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_fps_label'}, 0, 1, 1, 2, ['fill'], [], 2, 1);
		$widgets->{'menc_fps_label'}->show;
		$widgets->{'menc_fps_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'menc_time_label'
		$widgets->{'menc_time_label'} = new Gtk2::Label('Real time left:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_time_label'}, 0, 1, 0, 1, ['fill'], [], 2, 1);
		$widgets->{'menc_time_label'}->show;
		$widgets->{'menc_time_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'menc_filesize_label'
		$widgets->{'menc_filesize_label'} = new Gtk2::Label('Estimated filesize:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_filesize_label'}, 0, 1, 2, 3, ['fill'], [], 2, 1);
		$widgets->{'menc_filesize_label'}->show;
		$widgets->{'menc_filesize_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'menc_progress_label'
		$widgets->{'menc_progress_label'} = new Gtk2::Label('Time encoded:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_progress_label'}, 0, 1, 3, 4, ['fill'], [], 2, 1);
		$widgets->{'menc_progress_label'}->show;
		$widgets->{'menc_progress_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkLabel 'progress_value'
		$widgets->{'menc_seconds'} = new Gtk2::Label('0:00:00');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_seconds'}, 1, 2, 3, 4, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_seconds'}->show;
		$widgets->{'menc_seconds'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'menc_progress_label'
		$widgets->{'menc_bitrate_label'} = new Gtk2::Label('Average bitrates:');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_bitrate_label'}, 0, 1, 4, 5, ['fill'], [], 2, 1);
		$widgets->{'menc_bitrate_label'}->show;
		$widgets->{'menc_bitrate_label'}->set_alignment(0, 0.5);
					
		$widgets->{'menc_bitrate'} = new Gtk2::Label('0:0');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_bitrate'}, 1, 2, 4, 5, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_bitrate'}->show;
		$widgets->{'menc_bitrate'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'filesize'
		$widgets->{'menc_filesize'} = new Gtk2::Label('0mb');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_filesize'}, 1, 2, 2, 3, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_filesize'}->show;
		$widgets->{'menc_filesize'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'fps'
		$widgets->{'menc_fps'} = new Gtk2::Label('0fps');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_fps'}, 1, 2, 1, 2, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_fps'}->show;
		$widgets->{'menc_fps'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkLabel 'time'
		$widgets->{'menc_time'} = new Gtk2::Label('0min');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_time'}, 1, 2, 0, 1, ['expand', 'fill'], [], 2, 1);
		$widgets->{'menc_time'}->show;
		$widgets->{'menc_time'}->set_alignment(0.5, 0.5);
		#
		# Construct a GtkProgressBar 'progress'
		$widgets->{'menc_progress'} = new Gtk2::ProgressBar;
		$widgets->{'menc_progress'}->set_orientation('left_to_right');
		$widgets->{'mencoder_table'}->attach($widgets->{'menc_progress'}, 0, 2, 5, 6, ['fill'], [], 2, 2);
		$widgets->{'menc_progress'}->show;
		$widgets->{'right_vbox'}->set_child_packing($widgets->{'menc_frame'}, 0, 1, 0, 'start');

		$widgets->{'control_table'} = new Gtk2::Table(2, 2, 1);
		$widgets->{'control_table'}->show;
		
		$widgets->{'right_vbox'}->pack_end($widgets->{'control_table'}, 0, 1, 0);
		$widgets->{'right_vbox'}->set_child_packing($widgets->{'control_table'}, 0, 1, 0, 'start');
		
### BUTTONS

		# Construct a GtkHBox 'settings_hbox'
		$widgets->{'buttons_table'} = new Gtk2::Table(2, 2, 1);
		$widgets->{'buttons_frame'} = new Gtk2::Frame;
		$widgets->{'buttons_frame'}->set_border_width(2);
		$widgets->{'buttons_frame'}->add($widgets->{'buttons_table'});	
		$widgets->{'left_vbox'}->add($widgets->{'buttons_frame'});
		$widgets->{'buttons_frame'}->show_all;
		#
		# Construct a GtkButton 'quit_button'
		$widgets->{'quit_button'} = Gtk2::Button->new_from_stock('ar_quit');
		$widgets->{'buttons_table'}->attach($widgets->{'quit_button'}, 1, 2, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'quit_button'}->show;
		#
		# Construct a GtkButton 'progress_dialog_show_button'
		$widgets->{'progress_dialog_show_button'} = Gtk2::Button->new_from_stock('ar_compact');
		$widgets->{'buttons_table'}->attach($widgets->{'progress_dialog_show_button'}, 0, 1, 1, 2, ['expand', 'fill'], [], 2, 2);
		$widgets->{'progress_dialog_show_button'}->show;
		$widgets->{'progress_dialog_show_button'}->set_sensitive(0);
		#
    # Construct a GtkButton 'start_button'
    $widgets->{'start_button'} = Gtk2::Button->new_from_stock('ar_start');
    $widgets->{'buttons_table'}->attach($widgets->{'start_button'}, 1, 2, 0, 1, ['expand', 'fill'], [], 2, 2);
    $widgets->{'start_button'}->show;
		$widgets->{'start_button'}->set_sensitive(0);
		#
		# Construct a GtkButton 'stop_button'
		$widgets->{'stop_button'} = Gtk2::Button->new_from_stock('ar_stop');
		$widgets->{'buttons_table'}->attach($widgets->{'stop_button'}, 1, 2, 0, 1, ['expand', 'fill'], [], 2, 2);
		#
		# Construct a GtkButton 'view_button'
		$widgets->{'view_button'} = Gtk2::Button->new_from_stock('ar_view');
		#$widgets->{'buttons_table'}->attach($widgets->{'view_button'}, 0, 1, 0, 1, ['expand', 'fill'], [], 2, 2);
		#$widgets->{'view_button'}->show;
		$widgets->{'view_button'}->set_sensitive(0);
	  #$widgets->{'main_hbox'}->set_child_packing($widgets->{'right_vbox'}, 1, 1, 0, 'end');
    #
		# Construct a GtkButton 'queue_button'
		$widgets->{'queue_button'} = Gtk2::Button->new_from_stock('ar_queue');
		$widgets->{'buttons_table'}->attach($widgets->{'queue_button'}, 0, 1, 0, 1, ['expand', 'fill'], [], 2, 2);
		$widgets->{'queue_button'}->show;
		$widgets->{'queue_button'}->set_sensitive(0);
	  $widgets->{'main_hbox'}->set_child_packing($widgets->{'right_vbox'}, 1, 1, 0, 'end');

### PREVIEW TAB
		
		$widgets->{'preview_frame'} = new Gtk2::Frame("Preview");
		$widgets->{'preview_frame'}->set_border_width(2);
		$widgets->{'preview_table'} = new Gtk2::Table(2, 6, 0);		
		$widgets->{'preview_table'}->set_row_spacings($row_height);
		$widgets->{'preview_frame'}->add($widgets->{'preview_table'});
		$widgets->{'notebook'}->append_page($widgets->{'preview_frame'}, new Gtk2::Label("Preview"));
		$widgets->{'preview_socket'} = new Gtk2::Socket;
		$widgets->{'preview_socket_frame'} = new Gtk2::Frame;		
		$widgets->{'preview_socket_frame'}->set_shadow_type(GTK_SHADOW_IN);
		$widgets->{'preview_socket_frame'}->add($widgets->{'preview_socket'});
		$widgets->{'preview_table'}->attach($widgets->{'preview_socket_frame'}, 0, 2, 0, 1, ['expand', 'fill'], ['expand'], 2, 2);
		$widgets->{'preview_socket'}->realize;
		$widgets->{'preview_table'}->attach(new Gtk2::VBox, 0, 2, 1, 2, ['expand', 'fill'], ['expand', 'fill'], 2, 2);
		$widgets->{'preview_table'}->attach(new Gtk2::HSeparator, 0, 2, 2, 3, ['expand', 'fill'], [], 2, 2);
		
		my $dirname = dirname($INC{"AcidRip/interface.pm"});
		if (-e $dirname . "/logo.png") {
		  $widgets->{'preview_logo'} = new_from_file Gtk2::Image($dirname . "/logo.png");
		  $widgets->{'preview_table'}->attach($widgets->{'preview_logo'}, 0, 2, 0, 1, ['expand', 'fill'], ['expand'], 2, 2);		
		}
		
	  # Construct a GtkButton 'preview_button'
		$widgets->{'preview_button'} = Gtk2::Button->new_from_stock('ar_preview');
		$widgets->{'preview_button'}->set_sensitive(0);
		$widgets->{'preview_table'}->attach($widgets->{'preview_button'}, 0, 1, 4, 5, ['expand', 'fill'], [], 2, 2);
		#
	  # Construct a GtkButton 'stop_preview_button'
		$widgets->{'stop_preview_button'} = Gtk2::Button->new_from_stock('ar_stop');
		$widgets->{'preview_table'}->attach($widgets->{'stop_preview_button'}, 0, 1, 4, 5, ['expand', 'fill'], [], 2, 2);
		#
		# Construct a GtkCHECK 'flickbook_preview_check'
		$widgets->{'flickbook_preview_check'} = new Gtk2::CheckButton("Flickbook");
		$widgets->{'preview_table'}->attach($widgets->{'flickbook_preview_check'}, 1, 2, 3, 4, ['fill'], [], 2, 2 );
		#
		$widgets->{'embed_preview_check'} = new Gtk2::CheckButton("Embed");
		$widgets->{'preview_table'}->attach($widgets->{'embed_preview_check'}, 0, 1, 3, 4, ['fill'], [], 2, 2 );
		$widgets->{'preview_table'}->attach($widgets->{'view_button'}, 1, 2, 4, 5, ['expand', 'fill'], [], 2, 2 );
		$widgets->{'view_button'}->show;

		$widgets->{'preview_frame'}->show_all;
		$widgets->{'preview_socket_frame'}->hide;
		
### QUEUE TAB
		
		$widgets->{'queue_frame'} = new Gtk2::Frame("Queue");
		$widgets->{'queue_frame'}->set_border_width(2);
		$widgets->{'queue_table'} = new Gtk2::Table(2, 1, 0);		
		$widgets->{'queue_table'}->set_row_spacings($row_height);
		$widgets->{'queue_frame'}->add($widgets->{'queue_table'});
		$widgets->{'notebook'}->append_page($widgets->{'queue_frame'}, new Gtk2::Label("Queue"));

		$widgets->{'queue_text'} = new Gtk2::TextView;
		$widgets->{'queue_text'}->set_editable(0);
		$widgets->{'queue_scroll'} = new Gtk2::ScrolledWindow(undef, undef);
		$widgets->{'queue_scroll'}->set_policy('automatic', 'automatic');
		$widgets->{'queue_scroll'}->set_size_request(-1, 150);
		$widgets->{'queue_scroll'}->add($widgets->{'queue_text'});
		$widgets->{'queue_text_frame'} = new Gtk2::Frame;
		$widgets->{'queue_text_frame'}->add($widgets->{'queue_scroll'});
		$widgets->{'queue_text_frame'}->set_shadow_type(GTK_SHADOW_IN);
		$widgets->{'queue_table'}->attach($widgets->{'queue_text_frame'}, 0, 2, 0, 1, ['expand', 'fill'], ['expand', 'fill'], 2, 2);		

		# Construct a GtkButton 'clear_queue_button'
		$widgets->{'queue_clear_button'} = Gtk2::Button->new_from_stock('ar_clear');
		$widgets->{'queue_clear_button'}->set_sensitive(0);
		$widgets->{'queue_table'}->attach($widgets->{'queue_clear_button'}, 0, 1, 1, 2, ['expand', 'fill'], [], 2, 2);

		# Construct a GtkButton 'export_queue_button'
		$widgets->{'queue_export_button'} = Gtk2::Button->new_from_stock('ar_export');
		$widgets->{'queue_export_button'}->set_sensitive(0);
		$widgets->{'queue_table'}->attach($widgets->{'queue_export_button'}, 1, 2, 1, 2, ['expand', 'fill'], [], 2, 2);

		$widgets->{'queue_frame'}->show_all;

### ADDITIONAL SETTINGS
		
    # Construct a GtkDialog 'additional_settings_dialog'
    $widgets->{'additional_settings_frame'} = new Gtk2::Frame("Settings");
		$widgets->{'additional_settings_frame'}->show;
		$widgets->{'additional_settings_frame'}->set_border_width(2);
		$widgets->{'notebook'}->append_page($widgets->{'additional_settings_frame'}, new Gtk2::Label("Settings"));
		#
		# Construct a GtkVBox 'additional_settings_vbox'
		$widgets->{'additional_settings_vbox'} = new Gtk2::VBox; #$widgets->{'additional_settings_dialog'}->vbox;
		$widgets->{'additional_settings_frame'}->add($widgets->{'additional_settings_vbox'});
		$widgets->{'additional_settings_vbox'}->show;
	  #
	  # Construct a GtkTable 'additional_settings_table'
	  $widgets->{'additional_settings_table'} = new Gtk2::Table(11, 4, 0);
	  $widgets->{'additional_settings_vbox'}->add($widgets->{'additional_settings_table'});
	  $widgets->{'additional_settings_table'}->show;		
		$widgets->{'additional_settings_table'}->set_row_spacings($row_height);
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'tooltips_check'} = new Gtk2::CheckButton('Use tooltips');
		#$widgets->{'additional_settings_table'}->attach($widgets->{'tooltips_check'}, 2, 4, 6, 7, ['fill'], ['expand'], 2, 0);
		#$widgets->{'tooltips_check'}->show;
		$widgets->{'shutdown_check'} = new Gtk2::CheckButton('Shutdown');
		$widgets->{'additional_settings_table'}->attach($widgets->{'shutdown_check'}, 2, 4, 6, 7, ['fill'], ['expand'], 2, 0);
		$widgets->{'shutdown_check'}->show;
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'autoload_check'} = new Gtk2::CheckButton('Autoload DVD');
		$widgets->{'additional_settings_table'}->attach($widgets->{'autoload_check'}, 0, 2, 5, 6, ['fill'], ['expand'], 2, 0);
		$widgets->{'autoload_check'}->show;
		#
		# Construst a GtkCheckButton 'precache_check'
		$widgets->{'precache_check'} = new Gtk2::CheckButton('Pre-cache video');
		$widgets->{'additional_settings_table'}->attach($widgets->{'precache_check'}, 2, 4, 5, 6, ['fill'], ['expand'], 2, 0);
		$widgets->{'precache_check'}->show;
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'del_cache_check'} = new Gtk2::CheckButton('Delete cache');
		$widgets->{'additional_settings_table'}->attach($widgets->{'del_cache_check'}, 2, 4, 4, 5, ['fill'], ['expand'], 2, 0);
		$widgets->{'del_cache_check'}->show;
		#
		# Construst a GtkCheckButton 'autoload_check'
		$widgets->{'overwrite_check'} = new Gtk2::CheckButton('Overwrite files');
		$widgets->{'additional_settings_table'}->attach($widgets->{'overwrite_check'}, 0, 2, 6, 7, ['fill'], ['expand'], 2, 0);
		$widgets->{'overwrite_check'}->show;
		#
		# Construct a GtkLabel 'mencoder_label'
		$widgets->{'mencoder_label'} = new Gtk2::Label('MEncoder:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'mencoder_label'}, 0, 2, 0, 1, ['fill'], ['expand'], 2, 2 );
		$widgets->{'mencoder_label'}->show;
		$widgets->{'mencoder_label'}->set_alignment(0, 0.5 );
		#
		# Construct a GtkEntry 'mencoder_entry'
		$widgets->{'mencoder_entry'} = new Gtk2::Entry;
		$widgets->{'mencoder_entry'}->set_size_request(40, -1);
		$widgets->{'additional_settings_table'}->attach($widgets->{'mencoder_entry'}, 2, 4, 0, 1, ['expand', 'fill'], ['expand'], 2, 2 );
		$widgets->{'mencoder_entry'}->show;
		#
		# Construct a GtkLabel 'mplayer_label'
		$widgets->{'mplayer_label'} = new Gtk2::Label('MPlayer:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'mplayer_label'}, 0, 2, 1, 2, ['fill'], ['expand'], 2, 2 );
		$widgets->{'mplayer_label'}->show;
		$widgets->{'mplayer_label'}->set_alignment(0, 0.5 );
		#
		# Construct a GtkEntry 'mplayer_entry'
		$widgets->{'mplayer_entry'} = new Gtk2::Entry;
		$widgets->{'mplayer_entry'}->set_size_request(40, -1);
		$widgets->{'additional_settings_table'}->attach($widgets->{'mplayer_entry'}, 2, 4, 1, 2, ['expand', 'fill'], ['expand'], 2, 2 );
		$widgets->{'mplayer_entry'}->show;
		#
		# Construct a GtkLabel 'lsdvd_label'
		$widgets->{'lsdvd_label'} = new Gtk2::Label('lsdvd:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'lsdvd_label'}, 0, 2, 2, 3, ['fill'], ['expand'], 2, 2 );
		$widgets->{'lsdvd_label'}->show;
		$widgets->{'lsdvd_label'}->set_alignment(0, 0.5 );
		#
		# Construct a GtkEntry 'lsdvd_entry'
		$widgets->{'lsdvd_entry'} = new Gtk2::Entry;
		$widgets->{'lsdvd_entry'}->set_size_request(40, -1);
		$widgets->{'additional_settings_table'}->attach($widgets->{'lsdvd_entry'}, 2, 4, 2, 3, ['expand', 'fill'], ['expand'], 2, 2 );
		$widgets->{'lsdvd_entry'}->show;
		#
		# Construct a GtkCHECK 'cache_check'
		$widgets->{'cache_check'} = new Gtk2::CheckButton("Cache DVD");
		$widgets->{'additional_settings_table'}->attach($widgets->{'cache_check'}, 0, 2, 4, 5, ['fill'], ['expand'], 2, 2 );
		$widgets->{'cache_check'}->show;
		#
		# Construct a GtkLabel 'lsdvd_label'
		$widgets->{'cache_label'} = new Gtk2::Label('Cache:');
		$widgets->{'additional_settings_table'}->attach($widgets->{'cache_label'}, 0, 2, 3, 4, ['fill'], ['expand'], 2, 2 );
		$widgets->{'cache_label'}->show;
		$widgets->{'cache_label'}->set_alignment(0, 0.5);
		#
		# Construct a GtkEntry for cache location'expand'
		$widgets->{'cache_directory_entry'}  = new Gtk2::Entry;
		$widgets->{'cache_directory_entry'}->set_size_request(40, -1);
		$widgets->{'additional_settings_table'}->attach($widgets->{'cache_directory_entry'}, 2, 4, 3, 4, ['fill'], ['expand'], 2, 2 );
		$widgets->{'cache_directory_entry'}->show;
		#
		# Construct a GtkLabel for default language
		$widgets->{'language_label'} = new Gtk2::Label("Language:");
		$widgets->{'additional_settings_table'}->attach($widgets->{'language_label'}, 0, 2, 9, 10, ['fill'], ['expand'], 2, 2 );
		$widgets->{'language_label'}->set_alignment(0,0.5);
		$widgets->{'language_label'}->set_size_request(1, -1);
		$widgets->{'language_label'}->show;
		#
		# Construct a GtkEntry for default language
		$widgets->{'language_entry'} = new Gtk2::Entry;
		$widgets->{'additional_settings_table'}->attach($widgets->{'language_entry'}, 2, 4, 9, 10, ['fill'], ['expand'], 2, 2 );
		$widgets->{'language_entry'}->set_size_request(10, -1);
		$widgets->{'language_entry'}->show;
		#
		# Construct a GtkCHECK 'compact_check'
		$widgets->{'compact_check'} = new Gtk2::CheckButton("Compact box");
		$widgets->{'additional_settings_table'}->attach($widgets->{'compact_check'}, 0, 2, 7, 8, ['fill'], ['expand'], 2, 2 );
		$widgets->{'compact_check'}->show;
		#
		# Construct a GtkCHECK 'enforce_size_check'
		$widgets->{'enforce_space_check'} = new Gtk2::CheckButton("Enforce size");
		$widgets->{'additional_settings_table'}->attach($widgets->{'enforce_space_check'}, 2, 4, 7, 8, ['fill'], ['expand'], 2, 2 );
		$widgets->{'enforce_space_check'}->show;
		#
		# Construct a GtkCHECK 'ppc_bug_check'
		$widgets->{'ppc_bug_check'} = new Gtk2::CheckButton("PPC cropping");
		$widgets->{'additional_settings_table'}->attach($widgets->{'ppc_bug_check'}, 0, 2, 8, 9, ['fill'], ['expand'], 2, 2 );
		$widgets->{'ppc_bug_check'}->show;
		#
		# Construct a GtkCHECK 'eject_check'
		$widgets->{'eject_check'} = new Gtk2::CheckButton("Eject DVD");
		$widgets->{'additional_settings_table'}->attach($widgets->{'eject_check'}, 2, 4, 8, 9, ['fill'], ['expand'], 2, 2 );
		$widgets->{'eject_check'}->show;
		#
		$widgets->{'vcd_type_label'} = new Gtk2::Label("VCD");
		#$widgets->{'vcd_type_label'}->show;
		$widgets->{'additional_settings_table'}->attach($widgets->{'vcd_type_label'}, 0, 1, 9, 10, ['expand', 'fill'], ['expand'], 2, 2);

		$widgets->{'vcd_type_option'} = new Gtk2::OptionMenu;
		$widgets->{'vcd_type_menu'} = new Gtk2::Menu;
		$widgets->{'vcd_type_option'}->set_menu($widgets->{'vcd_type_menu'});
		$widgets->{'vcd_type_menu'}->append(new Gtk2::MenuItem("VCD"));
		$widgets->{'vcd_type_menu'}->append(new Gtk2::MenuItem("SVCD"));
		$widgets->{'vcd_type_menu'}->append(new Gtk2::MenuItem("XVCD"));
		$widgets->{'vcd_type_menu'}->append(new Gtk2::MenuItem("KVCD"));
		#$widgets->{'vcd_type_option'}->show_all;
		$widgets->{'additional_settings_table'}->attach($widgets->{'vcd_type_option'}, 1, 2, 9, 10, ['expand', 'fill'], ['expand'], 2, 2);

		$widgets->{'vcd_format_label'} = new Gtk2::Label("");
		#$widgets->{'vcd_format_label'}->show;
		$widgets->{'additional_settings_table'}->attach($widgets->{'vcd_format_label'}, 2, 3, 9, 10, ['expand', 'fill'], ['expand'], 2, 2);

		$widgets->{'vcd_format_option'} = new Gtk2::OptionMenu;
		$widgets->{'vcd_format_menu'} = new Gtk2::Menu;
		$widgets->{'vcd_format_option'}->set_menu($widgets->{'vcd_format_menu'});
		$widgets->{'vcd_format_menu'}->append(new Gtk2::MenuItem("PAL"));
		$widgets->{'vcd_format_menu'}->append(new Gtk2::MenuItem("NTSC"));
		#$widgets->{'vcd_format_option'}->show_all;
		$widgets->{'additional_settings_table'}->attach($widgets->{'vcd_format_option'}, 3, 4, 9, 10, ['expand', 'fill'], ['expand'], 2, 2);
		#
		# Construct a GtkButton 'save_button'
		$widgets->{'save_button'} = Gtk2::Button->new_from_stock('gtk-save');
		$widgets->{'additional_settings_table'}->attach($widgets->{'save_button'}, 0, 2, 10, 11, ['expand', 'fill'], [], 2, 2);
		$widgets->{'save_button'}->show;
	
		# Construct a GtkButton 'restore_button'
		$widgets->{'restore_button'} = Gtk2::Button->new_from_stock('gtk-revert-to-saved');
		$widgets->{'additional_settings_table'}->attach($widgets->{'restore_button'}, 2, 4, 10, 11, ['expand', 'fill'], [], 2, 2);
		$widgets->{'restore_button'}->show;
		
	  $widgets->{'main_hbox'}->set_child_packing($widgets->{'left_vbox'}, 1, 1, 0, 'start');
		
### DEBUG WINDOW
		
		# Construct a mencoder output frame
		$widgets->{'mencoder_output_frame'} = new Gtk2::Frame("Output log");
		$widgets->{'mencoder_output_frame'}->set_border_width(2);
		$widgets->{'status_vbox'}->add($widgets->{'mencoder_output_frame'});

		$widgets->{'output_vbox'} = new Gtk2::VBox;
		$widgets->{'output_vbox'}->show;
		#
		# Construct a mencoder output table
		$widgets->{'mencoder_output_table'} = new Gtk2::Table(4, 1, 0);
		$widgets->{'mencoder_output_frame'}->add($widgets->{'output_vbox'});
		$widgets->{'output_vbox'}->pack_start($widgets->{'mencoder_output_table'}, 0, 0, 2);
		#
		# construct a save button for mencoder output
		$widgets->{'mencoder_output_save_button'} = Gtk2::Button->new_from_stock('ar_log_save');
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_save_button'}, 0, 1, 0, 1, ['fill', 'expand'], [], 2, 2);

		$widgets->{'mencoder_output_clear_button'} = Gtk2::Button->new_from_stock('ar_clear');
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_clear_button'}, 2, 3, 0, 1, ['fill', 'expand'], [], 2, 2);

		$widgets->{'mencoder_output_hide_button'} = Gtk2::Button->new_from_stock('ar_log_hide');
		$widgets->{'mencoder_output_table'}->attach($widgets->{'mencoder_output_hide_button'}, 3, 4, 0, 1, ['fill', 'expand'], [], 2, 2);

		# Construct an mencoder output text
		$widgets->{'mencoder_output_text'} = new Gtk2::TextView;
		$widgets->{'mencoder_output_text'}->set_wrap_mode ('word');
		$widgets->{'mencoder_output_text'}->set_editable(0);
		$widgets->{'mencoder_output_scroll'} = new Gtk2::ScrolledWindow(undef, undef);

		$widgets->{'mencoder_output_scroll'}->set_policy('automatic', 'always');
		$widgets->{'mencoder_output_scroll'}->set_size_request(-1, 150);
		$widgets->{'mencoder_output_scroll'}->add($widgets->{'mencoder_output_text'});

		$widgets->{'mencoder_output_scroll'}->set_shadow_type(GTK_SHADOW_IN);
		$widgets->{'output_vbox'}->pack_start($widgets->{'mencoder_output_scroll'}, 1, 1, 2);
    $widgets->{'mencoder_output_scroll'}->show_all;

		$widgets->{'mencoder_output_text'}->get_buffer->create_tag("error", 'foreground' => "red");
		$widgets->{'mencoder_output_text'}->get_buffer->create_tag("lsdvd", 'foreground' => 'white', 'size-points' => "0");		
		$widgets->{'mencoder_output_text'}->get_buffer->create_tag("mplayer", 'foreground' => "darkgrey", 'wrap_mode' => "none");

### STATUS BAR
		
  	# Construct a GtkStatusbar
		$widgets->{'status_hbox'} = new Gtk2::HBox;
		$widgets->{'status_hbox'}->show;
		$widgets->{'status_vbox'}->add($widgets->{'status_hbox'});
  	$widgets->{'status_bar'} = new Gtk2::Statusbar;
  	$widgets->{'status_hbox'}->pack_start($widgets->{'status_bar'}, 1, 1, 2);
  	$widgets->{'status_bar'}->show;

		# Construct hide/show mencoder output button
		$widgets->{'mencoder_output_show_button'} = Gtk2::Button->new("Debug");
		$widgets->{'mencoder_output_show_button'}->show;
		$widgets->{'status_hbox'}->pack_end($widgets->{'mencoder_output_show_button'}, 0, 1, 2	);
    
### COMPACT DIALOG
		
    $widgets->{'progress_dialog'} = new Gtk2::Dialog;
    $widgets->{'progress_dialog'}->set_title('acidrip');
    $widgets->{'progress_dialog'}->set_resizable(0);
    $widgets->{'progress_dialog'}->set_modal(1);
    $widgets->{'progress_dialog'}->realize;
	 
		# Construct a GtkVBox 'additional_settings_vbox'
		$widgets->{'progress_vbox'} = $widgets->{'progress_dialog'}->vbox;
		$widgets->{'progress_vbox'}->show;
		
	  # Construct a GtkHBox 'additional_settings_action_area'
	  $widgets->{'progress_action_area'} = $widgets->{'progress_dialog'}->action_area;
	  $widgets->{'progress_action_area'}->show;
	  $widgets->{'progress_action_area'}->set_border_width(10);
		
		$widgets->{'progress_dialog_hide_button'} = new Gtk2::Button("Full view");
		$widgets->{'progress_dialog_hide_button'}->show;
		$widgets->{'progress_action_area'}->pack_end($widgets->{'progress_dialog_hide_button'}, 0, 1, 0);

### TOOLTIPS		

		$widgets->{'tooltips'} = new Gtk2::Tooltips();
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_width_spin'}, "Width of the video output, default 480, smaller width will encode faster.");
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_height_spin'}, "Height of the video output, default -2: calculates aspect based on crop and dvd information");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_width_spin'}, "Width of the crop, relative to original dvd video stream");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_height_spin'}, "Height of the crop, relative to the original dvd video stream");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_vertical_spin'}, "Vertical offset from top of video");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_horizontal_spin'}, "Horizontal offset from left side of video");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_enable_check'}, "Turn cropping on/off");
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_enable_check'}, "Turn video scaling on/off");
		$widgets->{'tooltips'}->set_tip($widgets->{'crop_detect_button'}, "Detect optimum crop values");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_codec_option'}, "Video output format to be used");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_options_entry'}, "Options specific to the selected video output");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_bitrate_entry'}, "Bitrate calculated to satify filesize. can be edited if desired");
		$widgets->{'tooltips'}->set_tip($widgets->{'subp_option'}, "Subpicture to be used");
		$widgets->{'tooltips'}->set_tip($widgets->{'read_dvd_button'}, "Load the dvd");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_passes_spin'}, "Number of encoding passes. Check MPlayer docs for details on 2 or 3 pass encoding.");
		$widgets->{'tooltips'}->set_tip($widgets->{'dvd_device_entry'}, "Location of the DVD device");
		$widgets->{'tooltips'}->set_tip($widgets->{'autoload_check'}, "Automatically load DVD and crop (if enabled) when program is loaded. (Remember to save settings!)");
		$widgets->{'tooltips'}->set_tip($widgets->{'overwrite_check'}, "Overwrite files if they already exist... woahh careful!");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_codec_option'}, "Audio output format to be used");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_options_entry'}, "Options specific to selected audio output");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_track_option'}, "Audio track to use");
		$widgets->{'tooltips'}->set_tip($widgets->{'filename_entry'}, "Name of output file:\n%T\tTrack title\n%N\tTrack number\n%L\ttrack length\n%f\tfirst title letter\n%w\tWidth\n%h\tHeight\n%b\tVideo bitrate\n%l\tLanguage");
		$widgets->{'tooltips'}->set_tip($widgets->{'filesize_spin'}, "Desired size of file(s), select typical values, or enter your own. If value is RED then you do not have enough space in the given location. Disabled if bitrate lock is checked");
		$widgets->{'tooltips'}->set_tip($widgets->{'save_button'}, "Store useful settings in $ENV{HOME}/.acidriprc");
		$widgets->{'tooltips'}->set_tip($widgets->{'restore_button'}, "Restore default settings");
		$widgets->{'tooltips'}->set_tip($widgets->{'start_button'}, "Begin encoding with current settings");
		$widgets->{'tooltips'}->set_tip($widgets->{'stop_button'}, "Stop encoding");
		$widgets->{'tooltips'}->set_tip($widgets->{'view_button'}, "Play back output file");
		$widgets->{'tooltips'}->set_tip($widgets->{'dvd_tree'}, "Contents of currently loaded DVD");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_show_button'}, "Show lots of lovely information about what's going on, useful for troubleshooting.");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_hide_button'}, "Hide all of this junk...");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_save_button'}, "Save all output information to $ENV{HOME}/acidrip.log.");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_bitrate_lock_check'}, "Lock bitrate from automatic updating");
		$widgets->{'tooltips'}->set_tip($widgets->{'scale_lock_check'}, "Lock height relative to width");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_output_clear_button'}, "Clear all output information");
		$widgets->{'tooltips'}->set_tip($widgets->{'video_bpp_entry'}, "Estimated bits per pixel. Ideally you want to hit around 0.25 with a decent divx codec");
		$widgets->{'tooltips'}->set_tip($widgets->{'more_options_entry'}, "Somewhere for any other options to go that are not handled here");
		$widgets->{'tooltips'}->set_tip($widgets->{'total_blocks_spin'}, "Automatically split dvd into a given number of files by chapter boundaries");
		$widgets->{'tooltips'}->set_tip($widgets->{'mencoder_entry'}, "Specify a set location for mencoder or similar, e.g. \"/mnt/nfs/usr/bin/mencoder\" or even \"nice mencoder\"");
		$widgets->{'tooltips'}->set_tip($widgets->{'language_entry'}, "Set preferred language for audio, reload DVD to take effect.");
		$widgets->{'tooltips'}->set_tip($widgets->{'cache_directory_entry'}, "Specify a set location for caching the DVD title to, e.g. \"/tmp\". You do NOT need to cache the dvd.");
		$widgets->{'tooltips'}->set_tip($widgets->{'cache_check'}, "To cache or not to cache. Useful if you're impatient and can\'t leave the disc for more than 30 mins... other than that...");
		$widgets->{'tooltips'}->set_tip($widgets->{'precache_check'}, "Caches all tracks before any encoding, otherwise tracks are cached and deleted at encode time.");
		$widgets->{'tooltips'}->set_tip($widgets->{'compact_check'}, "Show only encoding status when encoding title, smaller and less chance of accidentally stopping it!");
		$widgets->{'tooltips'}->set_tip($widgets->{'enforce_space_check'}, "Refuse to encode if there appears to not be enough space in output directory (encoding only, not caching)");
		$widgets->{'tooltips'}->set_tip($widgets->{'vf_pre_enable_check'}, "vf options to apply to video before cropping / scaling - see mplayer docs");
		$widgets->{'tooltips'}->set_tip($widgets->{'vf_post_enable_check'}, "vf options to apply to video after cropping / scaling - see mplayer docs");
		$widgets->{'tooltips'}->set_tip($widgets->{'info_field_option'}, "Set various attributes with the avi file. Few players besides MPlayer use this information.");
		$widgets->{'tooltips'}->set_tip($widgets->{'ppc_bug_check'}, "Mencoder\'s -sstep option doesn't work on PPC, use alternate (less reliable) crop method");
		$widgets->{'tooltips'}->set_tip($widgets->{'flickbook_preview_check'}, "Previews film with selected still shots instead of entire playback (not possible if using ppc bug)");
		$widgets->{'tooltips'}->set_tip($widgets->{'vobsubout_check'}, "Dump subtitles to seperate file instead of rendering directly to the video.");
    $widgets->{'tooltips'}->set_tip($widgets->{'embed_preview_check'}, "Show preview in space above, rather than a full size detached window");
		$widgets->{'tooltips'}->set_tip($widgets->{'eject_check'}, "Eject DVD when finished");
		$widgets->{'tooltips'}->set_tip($widgets->{'queue_button'}, "Add current setting to the queue");
		$widgets->{'tooltips'}->set_tip($widgets->{'vcd_type_option'}, "Load specifications for chosen VCD standard");
		$widgets->{'tooltips'}->set_tip($widgets->{'vcd_format_option'}, "Video size for VCD");
		$widgets->{'tooltips'}->set_tip($widgets->{'audio_gain_spin'}, "Audio gain (dB) -200 = silence, +40 = x1000!");
		$widgets->{'tooltips'}->set_tip($widgets->{'quit_button'}, "Quit AcidRip");
    $widgets->{'tooltips'}->set_tip($widgets->{'shutdown_check'}, "Shutdown machine when encoding is completed");

		$widgets->{'queue_export_button'}->signal_connect					('clicked', \&on_queue_export_button_clicked);
		$widgets->{'queue_clear_button'}->signal_connect					('clicked', \&on_queue_clear_button_clicked);
		$widgets->{'preview_button'}->signal_connect							('clicked', \&on_crop_preview_button_clicked);
		$widgets->{'crop_detect_button'}->signal_connect  	 		  ('clicked', \&on_crop_detect_button_clicked);
		$widgets->{'save_button'}->signal_connect									('clicked', \&on_save_settings_button_clicked);
		$widgets->{'restore_button'}->signal_connect							('clicked', \&on_restore_defaults_button_clicked);
		$widgets->{'start_button'}->signal_connect								('clicked', \&on_start_button_clicked);
		$widgets->{'stop_button'}->signal_connect									('clicked', \&on_stop_button_clicked);
		$widgets->{'queue_button'}->signal_connect								('clicked', \&on_queue_button_clicked);
		$widgets->{'stop_preview_button'}->signal_connect					('clicked', \&on_stop_preview_button_clicked);
		$widgets->{'view_button'}->signal_connect									('clicked', \&on_view_button_clicked);
		$widgets->{'scale_lock_check'}->signal_connect					  ('toggled', \&on_scale_lock_check_clicked);
		$widgets->{'mpegfile_option'}->signal_connect				  	  ('changed', \&on_mpegfile_option_changed);

		$widgets->{'mencoder_output_save_button'}->signal_connect	('clicked', \&on_mencoder_output_save_button_clicked);
		$widgets->{'mencoder_output_clear_button'}->signal_connect('clicked', \&on_mencoder_output_clear_button_clicked);
		$widgets->{'mencoder_output_show_button'}->signal_connect	('clicked', \&on_mencoder_output_show_button_clicked);
		$widgets->{'mencoder_output_hide_button'}->signal_connect	('clicked', \&on_mencoder_output_hide_button_clicked);

		bless ($widgets, $class);

		$widgets->connect_signals('toggled', \&on_setting_finished, 'tooltips_check', 'cache_check', 'autoload_check', 'crop_enable_check', 'precache_check',
			'scale_enable_check', 'overwrite_check', 'vf_pre_enable_check', 'vf_post_enable_check', 'del_cache_check', 'video_bitrate_lock_check', 'shutdown_check',
		  'enforce_space_check', 'compact_check', 'ppc_bug_check', 'flickbook_preview_check', 'vobsubout_check', 'embed_preview_check', 'eject_check');
		$widgets->connect_signals('changed', \&on_setting_finished, 'video_passes_spin', 'total_blocks_spin', 'vf_pre_entry', 'vf_post_entry');
		$widgets->connect_signals('focus_out_event', \&on_setting_finished, 'mplayer_entry', 'lsdvd_entry', 'mencoder_entry', 'video_bitrate_entry', 'video_bitrate_spin',
			'crop_height_spin', 'more_options_entry', 'crop_width_spin', 'crop_vertical_spin', 'crop_horizontal_spin', 'dvd_device_entry', 'language_entry',
			'video_options_entry', 'filename_entry', 'audio_options_entry', 'scale_width_spin', 'scale_height_spin', 'info_name_entry',
		  'info_artist_entry', 'info_subject_entry', 'info_genre_entry', 'info_copyright_entry', 'info_comment_entry', 
		  'cache_directory_entry', 'filesize_spin', 'title_entry', 'audio_gain_spin');
    $widgets->connect_signals('activate', \&on_setting_finished, 'dvd_device_entry');
    $widgets->connect_signals('changed', \&on_setting_changed, 'filesize_spin', 'crop_height_spin',
			'scale_width_spin', 'scale_height_spin', 'total_blocks_spin', 'crop_width_spin', 'crop_vertical_spin', 'crop_horizontal_spin',
		  'filename_entry', 'video_bitrate_spin');
		
		$widgets->{'dvd_device_entry'}->signal_connect							('activate', \&on_read_dvd_button_clicked);
		$widgets->{'video_bpp_entry'}->signal_connect								('changed', \&on_bpp_changed);
		$widgets->{'filesize_spin'}->signal_connect									('changed', \&on_filesize_changed);

		$widgets->{'read_dvd_button'}->signal_connect								('clicked', \&on_read_dvd_button_clicked, $widgets);

		$widgets->{'acidrip'}->signal_connect         	      		  ('delete_event', \&quit_acidrip);
		$widgets->{'quit_button'}->signal_connect      		     			('clicked', \&quit_acidrip);
		$widgets->{'progress_dialog_hide_button'}->signal_connect  	('clicked', \&progress_dialog_hide);
		$widgets->{'progress_dialog_show_button'}->signal_connect  	('clicked', \&progress_dialog_show);

		##################################################
		# NB subp and audio combo connects in signals.pm #
		##################################################

	Glib::Idle->add( sub {while (Gtk2->events_pending()) {Gtk2->main_iteration()}});

  return $widgets;
}

1;
